1
0
angie-conv-image/image-entry.d/00-common.envsh

283 lines
7.1 KiB
Bash

#!/bin/sh
volume_root='/run/angie'
tmp_dir="${volume_root}/tmp"
merged_root="${volume_root}/merged"
target_root="${volume_root}"
have_envvar() {
[ -n "$1" ] || return 1
grep -Ezq "^$1=" /proc/self/environ || return
}
## unexporting variable in (POSIX) sh is PITA =/
unexport() {
unset ___k ___v
for ___k ; do
[ -n "${___k}" ] || continue
have_envvar "${___k}" || continue
___v=$(eval printf '%s' "\"\${${___k}}\"")
eval "unset ${___k}"
eval "${___k}=$(env printf '%s' \"\${___v}\")"
unset ___v
done
unset ___k
}
## likely the same as in https://pkg.go.dev/strconv#ParseBool
gobool_to_int() {
## local value=$1
## local default=$2
case "${1:-_}" in
1 | [Tt] | [Tt][Rr][Uu][Ee] ) echo 1 ;;
0 | [Ff] | [Ff][Aa][Ll][Ss][Ee] ) echo 0 ;;
* ) echo "${2:-error}" ;;
esac
}
[ -n "${__IEP_SRC:-}" ] || __IEP_SRC="$0"
IEP_TRACE=$(gobool_to_int "${IEP_TRACE:-0}" 0)
export IEP_TRACE
if [ "${IEP_TRACE}" = 1 ] ; then
log_always() { echo "# $(date +'%Y-%m-%d %H:%M:%S.%03N %z'): ${__IEP_SRC}${*:+: $*}" >&2 ; }
else
log_always() { echo "# ${__IEP_SRC}${*:+: $*}" >&2 ; }
fi
IEP_VERBOSE=$(gobool_to_int "${IEP_VERBOSE:-${IEP_TRACE}}" "${IEP_TRACE}")
export IEP_VERBOSE
if [ "${IEP_VERBOSE}" = 1 ] ; then
log() { log_always "$@" ; }
else
log() { : ;}
fi
log_file() { sed -E '/^./s,^, ,' < "$1" >&2 ; }
if [ "${IEP_VERBOSE}" = 0 ] ; then
ln_s() { ln -s "$@" || return; }
cp_a() { cp -a "$@" || return; }
else
ln_s() { ln -sv "$@" || return; }
cp_a() { cp -av "$@" || return; }
fi
ln_cp() {
if [ -h "$1" ] ; then
ln_s "$(readlink -e "$1")" "$2"
else
cp_a "$1" "$2"
fi
}
have_cmd() { command -v "$1" >/dev/null 2>&1 || return ; }
strip_suffix() { printf '%s' "${1%"$2"}" | tr -s '/' ; }
untemplate_path() {
case "$1" in
## inplace
"${volume_root}"/* | /etc/angie/run/* )
strip_suffix "$1" "$2"
;;
/etc/angie/conf.d/* | /etc/angie/mod.d/* | /etc/angie/modules.d/* | /etc/angie/njs.d/* | /etc/angie/site.d/* | /etc/angie/snip.d/* )
strip_suffix "$1" "$2"
;;
/etc/angie/static.d/* )
strip_suffix "$1" "$2"
;;
## set appropriate location
/etc/angie/* )
strip_suffix "${volume_root}${1#/etc/angie}" "$2"
;;
/tmp/* )
log_always "untemplate_path() shouldn't work with /tmp/: $1"
strip_suffix "$1" "$2"
;;
## last resort - STRONGLY AVOID
/* )
log_always "untemplate_path() does uncommon/last-resort mapping for: $1"
strip_suffix "${tmp_dir}$1" "$2"
;;
## misbehavior!
* )
log_always "untemplate_path() doesn't work with relative paths: $1"
return 1
;;
esac
}
install_userdir() {
if [ "${IEP_ROOT}" = 1 ] ; then
install -d -o "${NGX_USER}" -g "${NGX_GROUP}" "$@"
else
install -d "$@"
fi
}
expand_file_envsubst() {
__r=0
for __src ; do
[ -n "${__src}" ] || continue
if ! [ -f "${__src}" ] ; then
__r=1
log_always "file not found: ${__src}"
continue
fi
case "${__src}" in
*.in ) ;;
* )
__r=1
log "expand_file_envsubst: file name extension mismatch: ${__src}"
continue
;;
esac
__dest=$(strip_suffix "${__src}" '.in')
if [ -e "${__dest}" ] ; then
__r=1
log "expand_file_envsubst: destination file already exists: ${__dest}"
continue
fi
log "Running envsubst: ${__src} -> ${__dest}"
envsubst.sh < "${__src}" > "${__dest}" || __r=1
done
unset __src __dest
return ${__r}
}
expand_file_jinja() {
j2-single "$@" || return $?
}
expand_dir_envsubst() {
__template_list=$(mktemp) || return
find "$@" -follow -type f -name '*.in' \
| sort -uV > "${__template_list}"
__have_args="${ENVSUBST_ARGS:+1}"
if [ -z "${__have_args}" ] ; then
## optimize envsubst.sh invocation by caching argument list
## ref: envsubst.sh
ENVSUBST_ARGS=$(mktemp) || return
envsubst-args.sh > "${ENVSUBST_ARGS}"
export ENVSUBST_ARGS
fi
__ret=0
while read -r __orig_file ; do
[ -n "${__orig_file}" ] || continue
expand_file_envsubst "${__orig_file}" || __ret=1
done < "${__template_list}"
unset __orig_file
if [ -z "${__have_args}" ] ; then
rm -f "${ENVSUBST_ARGS}" ; unset ENVSUBST_ARGS
fi
unset __have_args
rm -f "${__template_list}" ; unset __template_list
return ${__ret}
}
expand_dir_jinja() {
__template_list=$(mktemp) || return
find "$@" -follow -type f -name '*.j2' -printf '%p\0' \
| sort -zuV > "${__template_list}"
__ret=0
if [ -s "${__template_list}" ] ; then
xargs -0r -n 1000 -a "${__template_list}" \
j2-multi < /dev/null || __ret=1
fi
rm -f "${__template_list}" ; unset __template_list
return ${__ret}
}
remap_path() {
[ -n "$1" ] || return
case "$1" in
## conf
/etc/angie/conf.dist/* ) echo "${2:-/etc/angie/conf.d}${1#/etc/angie/conf.dist}" ;;
/etc/angie/conf/* ) echo "${2:-/etc/angie/conf.d}${1#/etc/angie/conf}" ;;
/angie/conf/* ) echo "${2:-/etc/angie/conf.d}${1#/angie/conf}" ;;
## mod
/etc/angie/mod.dist/* ) echo "${2:-/etc/angie/mod.d}${1#/etc/angie/mod.dist}" ;;
/etc/angie/mod/* ) echo "${2:-/etc/angie/mod.d}${1#/etc/angie/mod}" ;;
/angie/mod/* ) echo "${2:-/etc/angie/mod.d}${1#/angie/mod}" ;;
## modules
/etc/angie/modules.dist/* ) echo "${2:-/etc/angie/modules.d}${1#/etc/angie/modules.dist}" ;;
/etc/angie/modules/* ) echo "${2:-/etc/angie/modules.d}${1#/etc/angie/modules}" ;;
/angie/modules/* ) echo "${2:-/etc/angie/modules.d}${1#/angie/modules}" ;;
## njs
/etc/angie/njs.dist/* ) echo "${2:-/etc/angie/njs.d}${1#/etc/angie/njs.dist}" ;;
/etc/angie/njs/* ) echo "${2:-/etc/angie/njs.d}${1#/etc/angie/njs}" ;;
/angie/njs/* ) echo "${2:-/etc/angie/njs.d}${1#/angie/njs}" ;;
## site
/etc/angie/site.dist/* ) echo "${2:-/etc/angie/site.d}${1#/etc/angie/site.dist}" ;;
/etc/angie/site/* ) echo "${2:-/etc/angie/site.d}${1#/etc/angie/site}" ;;
/angie/site/* ) echo "${2:-/etc/angie/site.d}${1#/angie/site}" ;;
## snip
/etc/angie/snip.dist/* ) echo "${2:-/etc/angie/snip.d}${1#/etc/angie/snip.dist}" ;;
/etc/angie/snip/* ) echo "${2:-/etc/angie/snip.d}${1#/etc/angie/snip}" ;;
/angie/snip/* ) echo "${2:-/etc/angie/snip.d}${1#/angie/snip}" ;;
## static
/etc/angie/static.dist/* ) echo "${2:-/etc/angie/static.d}${1#/etc/angie/static.dist}" ;;
/etc/angie/static/* ) echo "${2:-/etc/angie/static.d}${1#/etc/angie/static}" ;;
/angie/static/* ) echo "${2:-/etc/angie/static.d}${1#/angie/static}" ;;
## log
/etc/angie/log.dist/* ) echo "${2:-/etc/angie/log.d}${1#/etc/angie/log.dist}" ;;
/angie/log/* ) echo "${2:-/etc/angie/log.d}${1#/angie/log}" ;;
## misbehavior!
* )
log_always "remap_path() doesn't know how to handle this path: $1"
return 1
;;
esac
}
combine_remap_path() {
[ -n "$1" ] || return
case "$1" in
"${merged_root}"/* ) echo "${2:-${target_root}}${1#"${merged_root}"}" ;;
## misbehavior!
* )
log_always "combine_remap_path() doesn't know how to handle this path: $1"
return 1
;;
esac
}
is_builtin_module() {
[ -n "${1:-}" ] || return 1
[ -n "${2:-}" ] || return 1
[ -f "/etc/angie/builtin.$1" ] || return 1
[ -s "/etc/angie/builtin.$1" ] || return 1
grep -Fxq -e "$2" "/etc/angie/builtin.$1" || return 1
}
sort_dedup_list() {
[ -n "$1" ] || return 0
printf '%s' "$1" \
| tr -s '[:space:]' '\n' | sort -uV | paste -sd ' ' \
| sed -zE 's/^\s+//;s/\s+$//'
}